DCMTK: IODImagePixelModule< T > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Private Attributes | List of all members
IODImagePixelModule< T > Class Template Reference

Class representing the Image Pixel Module: More...

Inheritance diagram for IODImagePixelModule< T >:

## Public Types
typedef T | value_type
| Data type of pixels.

## Public Member Functions
| IODImagePixelModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor.
| IODImagePixelModule ()
| Constructor.
virtual | ~IODImagePixelModule ()
| Destructor.
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read attributes from given item into this class.
virtual OFCondition | write (DcmItem &destination)
| Write attributes from this class into given item.
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of module.
virtual DataType | getDataType () const
| Get pixel data type, always returns DataType::INTEGER for this class.
virtual OFCondition | getBitsStored (Uint16 &value, const unsigned long pos=0)
| Get Bits Stored.
virtual OFCondition | getHighBit (Uint16 &value, const unsigned long pos=0)
| Get High Bit.
virtual OFCondition | getPixelRepresentation (Uint16 &value, const unsigned long pos=0)
| Get Pixel Representation.
virtual OFCondition | getPlanarConfiguration (Uint16 &value, const unsigned long pos=0)
| Get Planar Configuration.
virtual OFCondition | getICCProfile (OFVector< Uint8 > &values)
| Get ICC Profile.
virtual OFCondition | setSamplesPerPixel (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Samples per Pixel.
virtual OFCondition | setPhotometricInterpretation (const OFString &value, const OFBool checkValue=OFTrue)
| Set Photometric Interpretation.
virtual OFCondition | setBitsAllocated (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Bits Allocated.
virtual OFCondition | setBitsStored (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Bits Stored.
virtual OFCondition | setHighBit (const Uint16 value, const OFBool checkValue=OFTrue)
| Set High Bit.
virtual OFCondition | setPixelRepresentation (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Pixel Representation.
virtual OFCondition | setPlanarConfiguration (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Planar Configuration.
virtual OFCondition | setICCProfile (const Uint8 *values, const size_t length)
| Set ICC Profile.
Public Member Functions inherited from IODImagePixelBase
| IODImagePixelBase (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor.
| IODImagePixelBase ()
| Constructor.
virtual | ~IODImagePixelBase ()
| Destructor.
virtual OFCondition | getSamplesPerPixel (Uint16 &value, const unsigned long pos=0)
| Get Samples per Pixel.
virtual OFCondition | getPhotometricInterpretation (OFString &value, const signed long pos=0)
| Get Photometric Interpretation.
virtual OFCondition | getRows (Uint16 &value, const unsigned long pos=0)
| Get Rows.
virtual OFCondition | getColumns (Uint16 &value, const unsigned long pos=0)
| Get Columns.
virtual OFCondition | getBitsAllocated (Uint16 &value, const unsigned long pos=0)
| Get Bits Allocated.
virtual OFCondition | getPixelAspectRatio (Uint16 &value, const unsigned long pos=0)
| Get Pixel Aspect Ratio.
virtual OFCondition | setRows (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Rows.
virtual OFCondition | setColumns (const Uint16 value, const OFBool checkValue=OFTrue)
| Set Columns.
virtual OFCondition | setPixelAspectRatio (const OFString &verticalPixelSize, const OFString &horizontalPixelSize, const OFBool checkValue=OFTrue)
| Set Pixel Aspect Ratio.
Public Member Functions inherited from IODModule
| IODModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor.
| IODModule ()
| Constructor.
| IODModule (const IODModule &rhs)
| Copy constructor, creates shallow copy.
IODModule & | operator= (const IODModule &rhs)
| Assignment operator, creates shallow copy.
| ~IODModule ()
| Destructor.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor.
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch.
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set.
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set.
virtual | ~IODComponent ()
| Virtual Destructor.
void | clearData ()
| Clear all attributes from the data that are handled by this module.
virtual void | inventMissing ()
| Set missing values by inventing "default values".
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module.
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3.
DcmItem & | getData ()
| Get the data handled by this module.
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules.
virtual int | compare (const IODComponent &rhs) const
| Comparison operator for IOD Components.
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing.
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e.

## Static Private Attributes
static const OFString | m_ModuleName
| This module's name ("ImagePixelModule")

## Additional Inherited Members
Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name.
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name.
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class.
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e.

## Detailed Description

template<typename T>
class IODImagePixelModule< T >

Class representing the Image Pixel Module:

Samples Per Pixel: (US, 1, 1) Photometric Interpretation (CS, 1, 1) Rows: (US, 1, 1) Columns: (US, 1, 1) Bits Allocated: (US, 1, 1) Bits Stored: (US, 1, 1) High Bit: (US, 1, 1) Pixel Representation: (US, 1, 1) Pixel Data is left out for now Planar Configuration: (US, 1, 1C) Pixel Aspect Ratio: (IS, 2, 1C) ICC Profile: (OB, 1, 3)

## Constructor & Destructor Documentation

## ◆ IODImagePixelModule()

template<typename T>

IODImagePixelModule< T >::IODImagePixelModule | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules )

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.

## Member Function Documentation

## ◆ getBitsStored()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::getBitsStored | ( | Uint16 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Bits Stored.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getDataType()

template<typename T>

virtual DataType IODImagePixelModule< T >::getDataType | ( |  | ) | const
| virtual

Get pixel data type, always returns DataType::INTEGER for this class.

Returns
  The data type of the pixel data

Implements IODImagePixelBase.

## ◆ getHighBit()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::getHighBit | ( | Uint16 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get High Bit.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getICCProfile()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::getICCProfile | ( | OFVector< Uint8 > & | values | ) |
| virtual

Get ICC Profile.

Parameters

  values | Reference to variable in which the values should be stored

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getName()

template<typename T>

virtual OFString IODImagePixelModule< T >::getName | ( |  | ) | const
| virtual

Get name of module.

Returns
  Name of the module ("ImagePixelModule")

Reimplemented from IODImagePixelBase.

## ◆ getPixelRepresentation()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::getPixelRepresentation | ( | Uint16 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Pixel Representation.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getPlanarConfiguration()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::getPlanarConfiguration | ( | Uint16 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Planar Configuration.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ read()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::read | ( | DcmItem & | source,
|  | const OFBool | clearOldData = OFTrue )
| virtual

Read attributes from given item into this class.

Parameters

  source | The source to read from
  clearOldData | If OFTrue, old data is cleared before reading. Otherwise old data is overwritten (or amended)

Returns
  EC_Normal if reading was successful, error otherwise

Reimplemented from IODComponent.

## ◆ setBitsAllocated()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setBitsAllocated | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Bits Allocated.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setBitsStored()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setBitsStored | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Bits Stored.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setHighBit()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setHighBit | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set High Bit.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setICCProfile()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setICCProfile | ( | const Uint8 * | values,
|  | const size_t | length )
| virtual

Set ICC Profile.

Parameters

  values | Reference to variable in which the values should be stored
  length | Length of array provided in values parameter

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setPhotometricInterpretation()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setPhotometricInterpretation | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Photometric Interpretation.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setPixelRepresentation()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setPixelRepresentation | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Pixel Representation.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value' for conformance with VR (US) and consistency if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setPlanarConfiguration()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setPlanarConfiguration | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Planar Configuration.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value' for conformance with VR (US) and consistency with other attributes if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setSamplesPerPixel()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::setSamplesPerPixel | ( | const Uint16 | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Samples per Pixel.

Parameters

  value | Reference to variable in which the value should be stored
  checkValue | Check 'value' for conformance with VR (US) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ write()

template<typename T>

virtual OFCondition IODImagePixelModule< T >::write | ( | DcmItem & | destination | ) |
| virtual

Write attributes from this class into given item.

Parameters

  destination | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Reimplemented from IODComponent.

The documentation for this class was generated from the following files:

- dcmect/include/dcmtk/dcmect/enhanced_ct.h
- dcmiod/include/dcmtk/dcmiod/modimagepixel.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2